/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.67
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.62 2007/01/05 22:51:21 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.67 2007/01/09 15:48:34 cardoe Exp $
4# kate: encoding utf-8; eol unix; 4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off; 5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off; 6# kate: word-wrap-column 80; word-wrap off;
7 7
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 8# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
18 18
19# Shorten the path because the socket path length must be shorter than 107 chars 19# Shorten the path because the socket path length must be shorter than 107 chars
20# and we will run a mysql server during test phase 20# and we will run a mysql server during test phase
21S="${WORKDIR}/mysql" 21S="${WORKDIR}/mysql"
22 22
23[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070105" 23[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
24 24
25if [[ ${PR#r} -lt 60 ]] ; then 25if [[ ${PR#r} -lt 60 ]] ; then
26 IS_BITKEEPER=0 26 IS_BITKEEPER=0
27elif [[ ${PR#r} -lt 90 ]] ; then 27elif [[ ${PR#r} -lt 90 ]] ; then
28 IS_BITKEEPER=60 28 IS_BITKEEPER=60
124 124
125mysql_version_is_at_least "5.1.12" \ 125mysql_version_is_at_least "5.1.12" \
126&& IUSE="${IUSE} pbxt" 126&& IUSE="${IUSE} pbxt"
127 127
128RDEPEND="${DEPEND} 128RDEPEND="${DEPEND}
129sys-apps/mysql 129!minimal? ( sys-apps/mysql )
130selinux? ( sec-policy/selinux-mysql ) 130selinux? ( sec-policy/selinux-mysql )
131" 131"
132 132
133EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 133EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
134 pkg_postinst pkg_config pkg_postrm 134 pkg_postinst pkg_config pkg_postrm
172 172
173 if [[ ! -d "${wc_path}" ]]; then 173 if [[ ! -d "${wc_path}" ]]; then
174 local options="-r+" 174 local options="-r+"
175 # first check out 175 # first check out
176 einfo "bitkeeper check out start -->" 176 einfo "bitkeeper check out start -->"
177 einfo " repository: ${repo_uri}" 177 elog " repository: ${repo_uri}"
178 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \ 178 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
179 || die "${EBK}: can't fetch from ${repo_uri}." 179 || die "${EBK}: can't fetch from ${repo_uri}."
180 else 180 else
181 if [[ ! -d "${wc_path}/BK" ]]; then 181 if [[ ! -d "${wc_path}/BK" ]]; then
182 popd 182 popd
183 die "Look like ${wc_path} is not a bitkeeper path." 183 die "Look like ${wc_path} is not a bitkeeper path."
184 fi 184 fi
185 185
186 # update working copy 186 # update working copy
187 einfo "bitkeeper update start -->" 187 einfo "bitkeeper update start -->"
188 einfo " repository: ${repo_uri}" 188 elog " repository: ${repo_uri}"
189 189
190 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \ 190 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
191 || die "BK: can't update from ${repo_uri} to ${wc_path}." 191 || die "BK: can't update from ${repo_uri} to ${wc_path}."
192 fi 192 fi
193 193
273 myconf="${myconf} --without-${i}" 273 myconf="${myconf} --without-${i}"
274 done 274 done
275 myconf="${myconf} --with-extra-charsets=none" 275 myconf="${myconf} --with-extra-charsets=none"
276 myconf="${myconf} --enable-local-infile" 276 myconf="${myconf} --enable-local-infile"
277 277
278 if useq "static" ; then 278 if use static ; then
279 myconf="${myconf} --with-client-ldflags=-all-static" 279 myconf="${myconf} --with-client-ldflags=-all-static"
280 myconf="${myconf} --disable-shared" 280 myconf="${myconf} --disable-shared"
281 else 281 else
282 myconf="${myconf} --enable-shared --enable-static" 282 myconf="${myconf} --enable-shared --enable-static"
283 fi 283 fi
284 284
285 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 285 if mysql_version_is_at_least "4.01.00.00" && ! use latin1 ; then
286 myconf="${myconf} --with-charset=utf8" 286 myconf="${myconf} --with-charset=utf8"
287 myconf="${myconf} --with-collation=utf8_general_ci" 287 myconf="${myconf} --with-collation=utf8_general_ci"
288 else 288 else
289 myconf="${myconf} --with-charset=latin1" 289 myconf="${myconf} --with-charset=latin1"
290 myconf="${myconf} --with-collation=latin1_swedish_ci" 290 myconf="${myconf} --with-collation=latin1_swedish_ci"
298 myconf="${myconf} --with-mysqld-user=mysql" 298 myconf="${myconf} --with-mysqld-user=mysql"
299 myconf="${myconf} --with-server" 299 myconf="${myconf} --with-server"
300 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 300 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
301 myconf="${myconf} --without-libwrap" 301 myconf="${myconf} --without-libwrap"
302 302
303 if useq "static" ; then 303 if use static ; then
304 myconf="${myconf} --with-mysqld-ldflags=-all-static" 304 myconf="${myconf} --with-mysqld-ldflags=-all-static"
305 myconf="${myconf} --with-client-ldflags=-all-static" 305 myconf="${myconf} --with-client-ldflags=-all-static"
306 myconf="${myconf} --disable-shared" 306 myconf="${myconf} --disable-shared"
307 else 307 else
308 myconf="${myconf} --enable-shared --enable-static" 308 myconf="${myconf} --enable-shared --enable-static"
309 fi 309 fi
310 310
311 if useq "debug" ; then 311 if use debug ; then
312 myconf="${myconf} --with-debug=full" 312 myconf="${myconf} --with-debug=full"
313 else 313 else
314 myconf="${myconf} --without-debug" 314 myconf="${myconf} --without-debug"
315 mysql_version_is_at_least "4.1.3" \ 315 mysql_version_is_at_least "4.1.3" \
316 && useq "cluster" \ 316 && use cluster \
317 && myconf="${myconf} --without-ndb-debug" 317 && myconf="${myconf} --without-ndb-debug"
318 fi 318 fi
319 319
320 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 320 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
321 myconf="${myconf} --with-charset=utf8" 321 myconf="${myconf} --with-charset=utf8"
322 myconf="${myconf} --with-collation=utf8_general_ci" 322 myconf="${myconf} --with-collation=utf8_general_ci"
323 else 323 else
324 myconf="${myconf} --with-charset=latin1" 324 myconf="${myconf} --with-charset=latin1"
325 myconf="${myconf} --with-collation=latin1_swedish_ci" 325 myconf="${myconf} --with-collation=latin1_swedish_ci"
326 fi 326 fi
327 327
328 if useq "embedded" ; then 328 if use embedded ; then
329 myconf="${myconf} --with-embedded-privilege-control" 329 myconf="${myconf} --with-embedded-privilege-control"
330 myconf="${myconf} --with-embedded-server" 330 myconf="${myconf} --with-embedded-server"
331 else 331 else
332 myconf="${myconf} --without-embedded-privilege-control" 332 myconf="${myconf} --without-embedded-privilege-control"
333 myconf="${myconf} --without-embedded-server" 333 myconf="${myconf} --without-embedded-server"
341 myconf="${myconf} --with-extra-tools" 341 myconf="${myconf} --with-extra-tools"
342 myconf="${myconf} --with-innodb" 342 myconf="${myconf} --with-innodb"
343 myconf="${myconf} --without-readline" 343 myconf="${myconf} --without-readline"
344 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 344 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
345 345
346 if useq "ssl" ; then 346 if use ssl ; then
347 # --with-vio is not needed anymore, it's on by default and 347 # --with-vio is not needed anymore, it's on by default and
348 # has been removed from configure 348 # has been removed from configure
349 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 349 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
350 fi 350 fi
351 351
356 fi 356 fi
357 357
358 # The following fix is due to a bug with bdb on SPARC's. See: 358 # The following fix is due to a bug with bdb on SPARC's. See:
359 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 359 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
360 # It comes down to non-64-bit safety problems. 360 # It comes down to non-64-bit safety problems.
361 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then 361 if use sparc || use alpha || use hppa || use mips || use amd64 ; then
362 elog "Berkeley DB support was disabled due to incompatible arch" 362 elog "Berkeley DB support was disabled due to incompatible arch"
363 myconf="${myconf} --without-berkeley-db" 363 myconf="${myconf} --without-berkeley-db"
364 else 364 else
365 if useq "berkdb" ; then 365 if use berkdb ; then
366 myconf="${myconf} --with-berkeley-db=./bdb" 366 myconf="${myconf} --with-berkeley-db=./bdb"
367 else 367 else
368 myconf="${myconf} --without-berkeley-db" 368 myconf="${myconf} --without-berkeley-db"
369 fi 369 fi
370 fi 370 fi
372 if mysql_version_is_at_least "4.1.3" ; then 372 if mysql_version_is_at_least "4.1.3" ; then
373 myconf="${myconf} --with-geometry" 373 myconf="${myconf} --with-geometry"
374 myconf="${myconf} $(use_with cluster ndbcluster)" 374 myconf="${myconf} $(use_with cluster ndbcluster)"
375 fi 375 fi
376 376
377 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 377 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
378 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 378 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
379 myconf="${myconf} --with-archive-storage-engine" 379 myconf="${myconf} --with-archive-storage-engine"
380 380
381 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 381 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
382 myconf="${myconf} --with-csv-storage-engine" 382 myconf="${myconf} --with-csv-storage-engine"
393 myconf="${myconf} --with-federated-storage-engine" 393 myconf="${myconf} --with-federated-storage-engine"
394 fi 394 fi
395 fi 395 fi
396 396
397 mysql_version_is_at_least "5.0.18" \ 397 mysql_version_is_at_least "5.0.18" \
398 && useq "max-idx-128" \ 398 && use max-idx-128 \
399 && myconf="${myconf} --with-max-indexes=128" 399 && myconf="${myconf} --with-max-indexes=128"
400} 400}
401 401
402configure_51() { 402configure_51() {
403 # TODO: !!!! readd --without-readline 403 # TODO: !!!! readd --without-readline
408 myconf="${myconf} --with-geometry" 408 myconf="${myconf} --with-geometry"
409 myconf="${myconf} --with-readline" 409 myconf="${myconf} --with-readline"
410 myconf="${myconf} --with-row-based-replication" 410 myconf="${myconf} --with-row-based-replication"
411 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 411 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
412 myconf="${myconf} --without-pstack" 412 myconf="${myconf} --without-pstack"
413 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 413 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
414 414
415 # 5.1 introduces a new way to manage storage engines (plugins) 415 # 5.1 introduces a new way to manage storage engines (plugins)
416 # like configuration=none 416 # like configuration=none
417 local plugins="csv,myisam,myisammrg,heap" 417 local plugins="csv,myisam,myisammrg,heap"
418 if useq "extraengine" ; then 418 if use extraengine ; then
419 # like configuration=max-no-ndb, archive and example removed in 5.1.11 419 # like configuration=max-no-ndb, archive and example removed in 5.1.11
420 plugins="${plugins},archive,blackhole,example,federated,partition" 420 plugins="${plugins},archive,blackhole,example,federated,partition"
421 421
422 elog "Before using the Federated storage engine, please be sure to read" 422 elog "Before using the Federated storage engine, please be sure to read"
423 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 423 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
424 fi 424 fi
425 425
426 if useq "innodb" ; then 426 if use innodb ; then
427 plugins="${plugins},innobase" 427 plugins="${plugins},innobase"
428 fi 428 fi
429 429
430 # like configuration=max-no-ndb 430 # like configuration=max-no-ndb
431 if useq "cluster" ; then 431 if use cluster ; then
432 plugins="${plugins},ndbcluster" 432 plugins="${plugins},ndbcluster"
433 myconf="${myconf} --with-ndb-binlog" 433 myconf="${myconf} --with-ndb-binlog"
434 fi 434 fi
435 435
436 if mysql_version_is_at_least "5.2" ; then 436 if mysql_version_is_at_least "5.2" ; then
450 450
451 local myconf 451 local myconf
452 myconf="${myconf} --with-mysql=${S}" 452 myconf="${myconf} --with-mysql=${S}"
453 mkdir -p ${T}/lib 453 mkdir -p ${T}/lib
454 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 454 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}"
455 useq "debug" && myconf="${myconf} --with-debug=full" 455 use debug && myconf="${myconf} --with-debug=full"
456 # TODO is safe/needed to use econf here ? 456 # TODO is safe/needed to use econf here ?
457 ./configure ${myconf} || die "problem configuring pbxt storage engine" 457 ./configure ${myconf} || die "problem configuring pbxt storage engine"
458 # TODO is safe/needed to use emake here ? 458 # TODO is safe/needed to use emake here ?
459 make || die "problem making pbxt storage engine (${myconf})" 459 make || die "problem making pbxt storage engine (${myconf})"
460 460
475mysql_pkg_setup() { 475mysql_pkg_setup() {
476 enewgroup mysql 60 || die "problem adding 'mysql' group" 476 enewgroup mysql 60 || die "problem adding 'mysql' group"
477 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 477 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
478 478
479 # Check for USE flag problems in pkg_setup 479 # Check for USE flag problems in pkg_setup
480 if useq "static" && useq "ssl" ; then 480 if use static && use ssl ; then
481 eerror "MySQL does not support being built statically with SSL support enabled!" 481 eerror "MySQL does not support being built statically with SSL support enabled!"
482 die "MySQL does not support being built statically with SSL support enabled!" 482 die "MySQL does not support being built statically with SSL support enabled!"
483 fi 483 fi
484 484
485 if ! mysql_version_is_at_least "5.0" \ 485 if ! mysql_version_is_at_least "5.0" \
486 && useq "raid" \ 486 && use raid \
487 && useq "static" ; then 487 && use static ; then
488 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 488 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
489 eerror "with RAID support enabled." 489 eerror "with RAID support enabled."
490 die "USE flags 'raid' and 'static' conflict!" 490 die "USE flags 'raid' and 'static' conflict!"
491 fi 491 fi
492 492
493 if mysql_version_is_at_least "4.1.3" \ 493 if mysql_version_is_at_least "4.1.3" \
494 && ( useq "cluster" || useq "extraengine" ) \ 494 && ( use cluster || use extraengine ) \
495 && useq "minimal" ; then 495 && use minimal ; then
496 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 496 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
497 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 497 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
498 fi 498 fi
499 499
500 mysql_check_version_range "4.0 to 5.0.99.99" \ 500 mysql_check_version_range "4.0 to 5.0.99.99" \
501 && useq "berkdb" \ 501 && use berkdb \
502 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 502 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
503} 503}
504 504
505mysql_src_unpack() { 505mysql_src_unpack() {
506 # Initialize the proper variables first 506 # Initialize the proper variables first
551 local rebuilddirlist d 551 local rebuilddirlist d
552 552
553 if mysql_version_is_at_least "5.1.12" ; then 553 if mysql_version_is_at_least "5.1.12" ; then
554 rebuilddirlist="." 554 rebuilddirlist="."
555 # TODO IMPO! Check this with a cmake expert 555 # TODO IMPO! Check this with a cmake expert
556 useq "innodb" \ 556 use innodb \
557 && cmake \ 557 && cmake \
558 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 558 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \
559 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 559 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \
560 "storage/innobase" 560 "storage/innobase"
561 else 561 else
568 AT_GNUCONF_UPDATE="yes" eautoreconf 568 AT_GNUCONF_UPDATE="yes" eautoreconf
569 popd &>/dev/null 569 popd &>/dev/null
570 done 570 done
571 571
572 if mysql_check_version_range "4.1 to 5.0.99.99" \ 572 if mysql_check_version_range "4.1 to 5.0.99.99" \
573 && useq "berkdb" ; then 573 && use berkdb ; then
574 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 574 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
575 pushd "bdb/dist" \ 575 pushd "bdb/dist" \
576 && sh s_all \ 576 && sh s_all \
577 || die "Failed bdb reconfigure" \ 577 || die "Failed bdb reconfigure" \
578 &>/dev/null 578 &>/dev/null
585 mysql_init_vars 585 mysql_init_vars
586 586
587 # $myconf is modified by the configure_* functions 587 # $myconf is modified by the configure_* functions
588 local myconf="" 588 local myconf=""
589 589
590 if useq "minimal" ; then 590 if use minimal ; then
591 configure_minimal 591 configure_minimal
592 else 592 else
593 configure_common 593 configure_common
594 if mysql_version_is_at_least "5.1.10" ; then 594 if mysql_version_is_at_least "5.1.10" ; then
595 configure_51 595 configure_51
630 | xargs -0 -n100 sed -i \ 630 | xargs -0 -n100 sed -i \
631 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 631 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
632 632
633 emake || die "emake failed" 633 emake || die "emake failed"
634 634
635 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 635 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
636} 636}
637 637
638mysql_src_install() { 638mysql_src_install() {
639 # Make sure the vars are correctly initialized 639 # Make sure the vars are correctly initialized
640 mysql_init_vars 640 mysql_init_vars
641 641
642 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 642 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die
643 643
644 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 644 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
645 645
646 insinto "${MY_INCLUDEDIR}" 646 insinto "${MY_INCLUDEDIR}"
647 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 647 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
648 648
649 # Convenience links 649 # Convenience links
667 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null 667 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
668 done 668 done
669 fi 669 fi
670 670
671 # clean up stuff for a minimal build 671 # clean up stuff for a minimal build
672 if useq "minimal" ; then 672 if use minimal ; then
673 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 673 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
674 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 674 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
675 rm -f "${D}/usr/sbin/mysqld" 675 rm -f "${D}/usr/sbin/mysqld"
676 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 676 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
677 fi 677 fi
696 doins scripts/mysqlaccess.conf 696 doins scripts/mysqlaccess.conf
697 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \ 697 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
698 -e "s!@DATADIR@!${DATADIR}!g" \ 698 -e "s!@DATADIR@!${DATADIR}!g" \
699 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 699 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
700 > "${TMPDIR}/my.cnf.ok" 700 > "${TMPDIR}/my.cnf.ok"
701 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 701 if mysql_version_is_at_least "4.1" && use latin1 ; then
702 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 702 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
703 fi 703 fi
704 newins "${TMPDIR}/my.cnf.ok" my.cnf 704 newins "${TMPDIR}/my.cnf.ok" my.cnf
705 705
706 # Minimal builds don't have the MySQL server 706 # Minimal builds don't have the MySQL server
707 if ! useq "minimal" ; then 707 if ! use minimal ; then
708 # Empty directories ... 708 # Empty directories ...
709 diropts "-m0750" 709 diropts "-m0750"
710 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 710 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
711 dodir "${DATADIR}" 711 dodir "${DATADIR}"
712 keepdir "${DATADIR}" 712 keepdir "${DATADIR}"
723 723
724 # Docs 724 # Docs
725 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 725 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
726 726
727 # Minimal builds don't have the MySQL server 727 # Minimal builds don't have the MySQL server
728 if ! useq "minimal" ; then 728 if ! use minimal ; then
729 docinto "support-files" 729 docinto "support-files"
730 for script in \ 730 for script in \
731 support-files/my-*.cnf \ 731 support-files/my-*.cnf \
732 support-files/magic \ 732 support-files/magic \
733 support-files/ndb-config-2-node.ini 733 support-files/ndb-config-2-node.ini
782 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 782 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
783 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 783 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
784 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 784 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
785 785
786 # Minimal builds don't have the MySQL server 786 # Minimal builds don't have the MySQL server
787 if ! useq "minimal" ; then 787 if ! use minimal ; then
788 docinto "support-files" 788 docinto "support-files"
789 for script in \ 789 for script in \
790 support-files/my-*.cnf \ 790 support-files/my-*.cnf \
791 support-files/magic \ 791 support-files/magic \
792 support-files/ndb-config-2-node.ini 792 support-files/ndb-config-2-node.ini
798 for script in scripts/mysql* ; do 798 for script in scripts/mysql* ; do
799 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 799 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
800 done 800 done
801 fi 801 fi
802 802
803 einfo "you may want to read slotting upgrade documents in the overlay" 803 #einfo "you may want to read slotting upgrade documents in the overlay"
804 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then 804 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
805 # TODO tell it better ;-) 805 # TODO tell it better ;-)
806 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 806 elog "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
807 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 807 elog "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
808 einfo "if, after that you cannot start the mysql server" 808 elog "if, after that you cannot start the mysql server"
809 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 809 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
810 einfo "use the mysql upgrade script to restore the table" 810 elog "use the mysql upgrade script to restore the table"
811 einfo " or " 811 elog " or "
812 einfo "CREATE TABLE IF NOT EXISTS plugin (" 812 elog "CREATE TABLE IF NOT EXISTS plugin ("
813 einfo " name char(64) binary DEFAULT '' NOT NULL," 813 elog " name char(64) binary DEFAULT '' NOT NULL,"
814 einfo " dl char(128) DEFAULT '' NOT NULL," 814 elog " dl char(128) DEFAULT '' NOT NULL,"
815 einfo " PRIMARY KEY (name)" 815 elog " PRIMARY KEY (name)"
816 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;" 816 elog ") CHARACTER SET utf8 COLLATE utf8_bin;"
817 fi 817 fi
818 mysql_check_version_range "4.0 to 5.0.99.99" \ 818 mysql_check_version_range "4.0 to 5.0.99.99" \
819 && useq "berkdb" \ 819 && use berkdb \
820 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 820 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
821} 821}
822 822
823mysql_pkg_config() { 823mysql_pkg_config() {
824 # Make sure the vars are correctly initialized 824 # Make sure the vars are correctly initialized

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.67

  ViewVC Help
Powered by ViewVC 1.1.20